#include "../../emu/h/types.h"
#include <stdio.h>
#include <string.h>
#include "../../emu/h/emuFileHandling.h"
#include "../../emu/h/emuGeneral.h"
#include "../../nes/h/nesGeneral.h"
#include "../../nes/h/ppu.h"

extern char szFilename[260];

int LoadHeader(u8 *header)
{
	long size;

	FILE *fileId;
	fileId = fopen(szFilename,"rb");		//Read Binary files
	if (fileId == 0)						//Check if it worked/opened
		return 0;
	
	fseek(fileId, 0, SEEK_END);				//Goto the end
	size = ftell(fileId);					//Get File Size
	
	fseek(fileId, 0, SEEK_SET);				//Set it to the beginning
	fread(header, 1, 16, fileId);			//read 16 byte header
	fclose(fileId);							//done, close it

	return size;							//return image size
}

void dumpImage()
{
	/*
	u8 iheader[16];
	
	FILE *fileId;
	fileId = fopen(szFilename,"wb");
	if (fileId == 0)
	{
		emuMsg("Could not write to file");
		return;
	}
	memset(iheader, 0, sizeof(iheader));
	iheader[0] = 'N'; iheader[1] = 'E'; iheader[2] = 'S'; iheader[3] = 0x1A;
	iheader[4] = header.prg;
	iheader[5] = header.chr;
	iheader[6] = 
		(header.vmirror	?1 :0) |
		(header.sram	?2 :0) |
		//Dont want trainers
		(header.fourScreenMirroring ?8 :0) |
		(header.mapNumber & 0x0F)<<4;
	
	iheader[7] = (header.mapNumber & 0xF0);

	fseek(fileId, 0, SEEK_SET);
	fwrite(iheader, 1, 16, fileId);
	
	fwrite(prgromPtr, 1, (header.prg * 0x400 * 16), fileId);
	if (header.chr)
		fwrite(chrromPtr, 1, (header.chr * 0x400 * 8), fileId);
	
	fclose(fileId);
	if (header.footerText)
	{
		delete [] header.footerText;
		header.footerText = NULL;
		header.footer = 0;
	}
	header.junk = 0;
*/
}

void LoadWram()
{
	/*
	FILE *f; unsigned int i;
	char szPath[260];

	GetLocalPath("save\\", "sav", szPath, sizeof(szPath));

	f = fopen(szPath, "rb");
	if (f == 0)
		return;

	fseek(f, 0, SEEK_SET);
	if ((i = fread(wram, 1, sramSize, f)) != sramSize)
		emuMsg("Error in load sram");

	fclose(f);
	*/
}

void SaveWram()
{
	/*
	FILE *f;
	char szPath[260];

	if (!header.sram)
		return;

	GetLocalPath("save\\", "sav", szPath, sizeof(szPath));

	f = fopen(szPath, "wb");
	if (f == 0)
	{
		emuMsg( "Could not save SRAM" );
		return;
	}
	fseek(f, 0, SEEK_SET);				//Set file to the beginning
	if (fwrite(wram, 1, sramSize, f) != sramSize)
		emuMsg("Error in save sram");
	fclose(f);							//done, close it
	*/
}

int loadImage(int size)
{
	
	FILE *fileId; int i;
	
	i = SetPrgChrMemory();
	if (i)
		return 0;

	imageSize = size;

	fileId = fopen(szFilename, "rb");
	if (!fileId)
	{
		emuMsg("Error loading file");
		return 0;
	}

	fseek(fileId, header.trainer ? 512: 16, SEEK_SET);
	fread(prgromPtr, 1, header.prg * 0x400 * 16, fileId);
	fread(chrromPtr, 1, header.chr * 0x400 * 8,  fileId);
	if (header.footer)
	{
		int iEnd, iEOF;
		fseek(fileId, 0, SEEK_END);
		iEOF = ftell(fileId);
		iEnd = size + ( header.trainer ? 512+16 : 16 );
		header.footerText = new char [iEOF-iEnd+1];
		fseek(fileId, iEnd, SEEK_SET);
		fread(header.footerText, 1, iEOF-iEnd, fileId);
		header.footerText[iEOF-iEnd] = 0;
	}
	fclose(fileId);	

	setRegionMode(szFilename);
	return size;
}

int SetPrgChrMemory()
{
	prgromPtr	= new u8 [header.prg * 0x400 * 16];
	chrromPtr	= new u8 [header.chr * 0x400 * 8];
	return 0;
}

int initMemory()
{
	ram			= new u8 [ramSize];
	wram		= new u8 [wramSize];
	chrRam		= new u8 [chrramSize];
	nameTable	= new u8 [NtSize];
	return 0;
}

void uninitMemory()
{
	if (ram)
	{
		delete [] ram;
		ram = 0;
	}
	if (wram)
	{
		delete [] wram;
		wram = 0;
	}
	if (chrRam)
	{
		delete [] chrRam;
		chrRam = 0;
	}
	if (nameTable)
	{
		delete [] nameTable;
		nameTable = 0;
	}
	if (prgromPtr)
	{
		delete [] prgromPtr;
		prgromPtr = 0;
	}
	if (chrromPtr)
	{
		delete [] chrromPtr;
		chrromPtr = 0;
	}
}


void SetLocalPath(char *sz)
{
	//strcpy(szLocalPath, sz);
}

void deletePrgChrMemory()
{
	if (prgromPtr)
		delete prgromPtr;
	prgromPtr = 0;
	if (chrromPtr)
		delete chrromPtr;
	chrromPtr = 0;
	return;
}

char postLoadInfo;

int postLoad()
{
	if (postLoadInfo == 1)
	{
//		dumpImage();
		loadPath();
		return 1;
	}
	return 0;
}

void setRegionMode(int regionNumber)
{
	nesMode = (nesMode & (-1 ^ regionModeAnd)) | regionNumber | resetLoop;
	brunNes = 0;
}


#define MessageBox(a, b, c, d) 0
#define IDYES 6

int checkHeadInfo(int val)
{
	//postLoadInfo = 0;
	if (val & 0x20)
	{
		header.mapNumber &= 0xf;
		if (MessageBox(mainWnd, "DiskDude! rom. Do you want to clean the header (along with other extra/bad data) ? DiskDude usually have bad headers, may need to change header info", wndName, MB_YESNO) == IDYES)
		{
			postLoadInfo = 1;
			return 0;
		}
	}
	else if (val & 0x40)
	{
		if (MessageBox(mainWnd, "Junk in the header (byte 8-F are not zeros), do you want to clean the header?", wndName, MB_YESNO) == IDYES)
		{
			postLoadInfo = 1;
			return 0;
		}
	}
	switch (val & ~(0x20 | 0x40))
	{
		case 0: break;	//its good
		case 2:
			MessageBox(mainWnd, "Invalid Header", wndName, MB_OK);
			return 2;
			break;
		case 3:
			MessageBox(mainWnd, "No Prg Rom", wndName, MB_OK);
			return 3;
			break;
		case 4:
			if (MessageBox(mainWnd, "PrgRom is not a multiple of 2, do you want to continue", wndName, MB_YESNO) != IDYES)
				return 4;
			break;
		case 5:
			if (MessageBox(mainWnd, "Remove Footer? (and other junk data)", wndName, MB_YESNO) == IDYES)
				return 1;
			break;
		case 6:
			if (MessageBox(mainWnd, "Garbage at end of rom?, Do you want to remove it?", wndName, MB_YESNO) == IDYES)
				return 1;
			break;
		case 7:
			MessageBox(mainWnd, "Missing 512 bytes which is the size of a trainer. Try clearing the trainer bit and reloading the image", wndName, MB_OK);
				return 7;
			break;
		case 8:
		case 9:
			MessageBox(mainWnd, "Missing Data", wndName, MB_OK);
			return 9;
			break;
		default:
			MessageBox(mainWnd,"Unknown Return value from checkHeader()", wndName, MB_OK);
			return -1;
			break;
	}
	return 0;
}
/*
	2 Bad header sig
	3 no prg rom ?
	4 prg isnt multiple of 2
	5 average footer found
	6 garbage at end
	7 no trainer but it thinks there is
	8 missing stuff
	9 missing stuff
	D5 DiskDude! <--crap
	D6 junk in header
*/

#ifdef WIN32

	#undef MessageBox
	#include <windows.h>

	int createFolder(char *szFoldername)
	{
		return !CreateDirectory(szFoldername, 0);
	}
#else
	int createFolder(char *szFoldername)
	{
		return 0;
	}
#endif

